'Tasteranbindung mittels RS485 an die Loxone RS485 Extension
'Christian Kreuzer
'V0.00   22.10.2012  Programm begonnen
'V0.10   03.12.2012  Programm getestet und lauffhig
'V0.20   04.12.2012  Bootloader integriert
'V0.30   24.03.2013  RS485 Paritt von None auf Even gendert, erste Temperatursendung nach einer Minute
'V0.31   30.03.2014  Hard-und Firmwareversion, Kommentare angepasst

$regfile = "m8adef.dat"
$crystal = 4000000
$hwstack = 40
$swstack = 16
$framesize = 32
$loadersize = 1024                                          'Bootloader vorhanden
'$sim


Ddrb = &B00101100
Portb = &B11010011
Ddrc = &B00100001
Portc = &B11011100
Ddrd = &B00000010
Portd = &B11111101

Const Rx_max_length = 20                                    'Lnge des Empfangspuffers in Byte
Const Rx_max_length_m1 = 19                                 'Lnge des Empfangspuffers in Byte
Const Tx_max_length = 40                                    'Lnge des Sendepuffers
Const Hw_vers = &H3032                                      'Hardwareversion 02 als ASCII
Const Fw_vers = &H3033                                      'Firmwareversion 03 als ASCII

Dim B_rx_puffer(rx_max_length) As Byte                      ' At S_rx_puffer Overlay
Dim B_rx_length As Byte                                     'aktuelle Pufferlnge

Dim B_tx_puffer(tx_max_length) As Byte                      'Sendepuffer
Dim B_tx_off As Byte                                        'Zhler zur Sendesperre (bei 0 darf gesendet werden)
Dim B_tx_pos As Byte                                        'aktuelle Position im Puffer

Dim B_adress As Byte                                        'Eigene Moduladresse
Dim B_adress_rom As Eram Byte At &H02
Dim Bi_adress_ok As Bit                                     'gltige Adresse

Dim B_taster(3) As Byte                                     'Puffer fr Tasterabbild

Dim B_led_puffer As Byte                                    'Abbild der LEDs
Dim B_led_out As Byte                                       'Ausgangsabbild der LEDs

Dim B_zaehler_us As Byte                                    'Zhler in 500us Schritten bis 10ms (Taster- Entprellen, 10ms Zhler)
Dim W_zaehler_ms As Word                                    'Zhler in 10ms Schritten bis 1min
Dim B_zaehler_temperatur As Byte                            'Zhler in 1min Schritten bis 5 fr Temperaturmessungen

Dim Bi_ai1_avilable As Bit                                  'Analogeingang 1 belegt
Dim W_temperaturen(4) As Word                               'Speicher fr Mittelwertbildung

Dim I As Byte                                               'allgemeine Zhlvariable (Schleifen,...)
Dim W_temp As Word
Dim B_temp As Byte
Dim I_temp As Integer
Dim S_temp As String * 10
Dim Bs_temp(11) As Byte At S_temp Overlay


'  -----------------------------------------------------------------------------
Di3 Alias Pinb.0                                            'Taster 3
Di2 Alias Pinb.1                                            'Taster 2
'Alias PORTb.2                                               'Ausgang wegen SPI Master
'Alias Portb.3                                               'SPI Sendeleitung
'Alias Pinb.4                                                'SPI Empfangsleitung
'Alias Portb.5                                               'SPI Clock
'Alias Pinb.6                                                'Quarz
'Alias Pinb.7                                                'Quarz

Ss_out Alias Portc.0                                        'SPI Select Ausgangsschieberegister
'Alias Pinc.1                                                'Analogeingang 1 (Temperatur MCP9701)
'Alias Pinc.2                                                'Analogeingang 2 ACHTUNG PULL UP GESETZT
Di1 Alias Pinc.3                                            'Taster 1
'Alias Pinc.4                                                'Reserve
Tx_active Alias Portc.5                                     'RS485 Sender aktiv
'Alias Pinc.6                                                'Reset

'Alias Pind.0                                                'Empfangsleitung RS485
'Alias Portd.1                                               'Sendeleitung RS485
Progt Alias Pind.2                                          'Programmiertaste
Di8 Alias Pind.3                                            'Taster 8
Di7 Alias Pind.4                                            'Taster 7
Di6 Alias Pind.5                                            'Taster 6
Di5 Alias Pind.6                                            'Taster 5
Di4 Alias Pind.7                                            'Taster 4


'Busanbindung
Config Com1 = 19200 , Synchrone = 0 , Parity = Even , Stopbits = 1 , Databits = 8 , Clockpol = 0
Config Print0 = Portc.5 , Mode = Set
On Urxc Rx_irq

'SPI fr Ausgangsschieberegister
Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Spiinit

'ADC
Config Adc = Single , Prescaler = Auto , Reference = Internal_2.56       'Avcc

'Timer
Config Timer0 = Timer , Prescale = 8                        ' Irq alle 500s
On Timer0 Timer0_irq
Enable Timer0

'Watchdog
Config Watchdog = 64
Stop Watchdog

'Initialisierung
B_adress = B_adress_rom                                     'Moduladresse
B_led_puffer = B_adress - 64
If B_adress > 64 Then Set Bi_adress_ok
If B_adress > 90 Then Reset Bi_adress_ok
Gosub P_led_out                                             'Ermglicht Loxone das Booten
Wait 5
W_temp = Getadc(1)
B_temp = B_adress - 64
For B_temp = B_temp To 0 Step -1                            'Verschiedene Startzeiten zum Verhindern von Datenkollisionen
   B_led_puffer = B_temp
   Gosub P_led_out
   Waitms 500
Next B_temp
B_led_puffer = 0
Gosub P_led_out

For B_tx_pos = 1 To Tx_max_length                           'Array lschen
   B_tx_puffer(b_tx_pos) = 0
Next B_tx_pos
For B_temp = 1 To Rx_max_length                             'Array lschen
   B_rx_puffer(b_temp) = 0
Next B_temp

'berprfung ob ein Temperatursensor angeschlossen (Uin>0V)
W_temp = Getadc(1)
Reset Bi_ai1_avilable
If W_temp > 10 Then
   Set Bi_ai1_avilable                                      'Temperatursensor angeschlossen
   For B_zaehler_temperatur = 1 To 4                        'aktuelle Temperatur nach einer Minute senden
      W_temperaturen(b_zaehler_temperatur) = Getadc(1)
   Next
   'Gosub P_temp_senden
End If

B_taster(1) = 0
B_taster(2) = 0
B_taster(3) = 0

B_zaehler_us = 0
W_zaehler_ms = 0

Enable Urxc
Reset Watchdog
Start Watchdog
Enable Interrupts

'##############################################################################
'Hauptprogramm
'##############################################################################

Hauptschleife:
Do
   If Progt = 0 Then Gosub P_programmiermodus               'Programmiertaste gedrckt
   If Bi_adress_ok = 0 Then Goto Hauptschleife              'ungltige Adresse
   If B_zaehler_us >= 19 Then                               '10ms Takt
      Gosub P_taster_abfragen                               'Taster abfragen
      Incr W_zaehler_ms
      B_zaehler_us = 0
   End If
   If W_zaehler_ms >= 6000 Then                             '1 Min Takt
      If Bi_ai1_avilable = 1 Then
         Incr B_zaehler_temperatur
         If B_zaehler_temperatur < 5 Then
            W_temperaturen(b_zaehler_temperatur) = Getadc(1)
         Else
            Gosub P_temp_senden
            B_zaehler_temperatur = 0
         End If
      End If
      W_zaehler_ms = 0
   End If
   If B_rx_length = Rx_max_length Then Gosub P_rx_auswertung       'empfangenes Telegramm auswerten
   'Senden
   If B_tx_off = 0 And B_tx_puffer(1) > 1 Then              'keine Sendesperre und irgendwas im Puffer
      Ucsrb.4 = 0                                           'Empfnger deaktivieren
      For B_tx_pos = 1 To Tx_max_length                     'Alle Daten != 0 senden und Array lschen
         If B_tx_puffer(b_tx_pos) = 0 Then Exit For
         Printbin B_tx_puffer(b_tx_pos) ; 1
         B_tx_puffer(b_tx_pos) = 0
      Next B_tx_pos
      B_temp = Inkey()                                      'Puffer leeren und Empfnger aktivieren
      Ucsrb.4 = 1
   End If
   Reset Watchdog
   Power Idle
Loop




'##############################################################################
'Unterprogramme
'##############################################################################
P_programmiermodus:
   Stop Watchdog
   B_led_puffer = 255
   Gosub P_led_out
   Wait 1
   For B_temp = 1 To Rx_max_length                          'Array lschen
      B_rx_puffer(b_temp) = 0
   Next B_temp
   Do
      If B_rx_length = Rx_max_length Then                   'Telegramm empfangen
         'Kontrolle auf STX ?SET"Adresse"ETX
         For I = 1 To Rx_max_length                         'Telegrammlnge
            If B_rx_puffer(i) = 0 Then Exit For
         Next I
         If I <> 8 Then Goto P_programmiermodus             'Daten ungltig
         If B_rx_puffer(1) <> 2 Then Goto P_programmiermodus       'STX
         If B_rx_puffer(2) <> 42 Then Goto P_programmiermodus       '*
         If B_rx_puffer(3) <> 83 Then Goto P_programmiermodus       'S
         If B_rx_puffer(4) <> 69 Then Goto P_programmiermodus       'E
         If B_rx_puffer(5) <> 84 Then Goto P_programmiermodus       'T
         If B_rx_puffer(7) <> 3 Then Goto P_programmiermodus       'ETX
         B_adress_rom = B_rx_puffer(6)                      'Adresse speichern
         Start Watchdog
      End If
      If Progt = 0 Then Start Watchdog
   Loop
Return


'Abragen der Taster, Entprellen und Einfgen der nderungen in den Sendepuffer
P_taster_abfragen:
   B_taster(3) = B_taster(2)
   B_taster(2) = B_taster(1)
   'Taster von den Ports geordnet in den Puffer kopieren
   B_taster(1).0 = Di1
   B_taster(1).1 = Di2
   B_taster(1).2 = Di3
   B_taster(1).3 = Di4
   B_taster(1).4 = Di5
   B_taster(1).5 = Di6
   B_taster(1).6 = Di7
   B_taster(1).7 = Di8
   B_taster(1) = Not B_taster(1)                            'invertieren
   'Entprellen
   B_temp = B_taster(1) Xor B_taster(2)
   B_temp = Not B_temp
   B_taster(3) = B_taster(1) Xor B_taster(3)
   B_temp = B_taster(3) And B_temp                          'alle genderten Eingnge in B_temp.x = 1
   Gosub P_taster_senden
Return

'Sendet den Status aller Eingnge welche mit B_temp.x = 1 maskiert sind
P_taster_senden:
   For I = 0 To 7
      If B_temp.i = 1 Then                                  'Taste gendert
         For B_tx_pos = 1 To Tx_max_length                  'ersten freien Platz im Array suchen
            If B_tx_puffer(b_tx_pos) = 0 Then Exit For
         Next B_tx_pos
         'Kontrolle genug freier Puffer
         B_tx_pos = B_tx_pos + 6
         If B_tx_pos > Tx_max_length Then Exit For
         B_tx_pos = B_tx_pos - 6
         'Sendepuffer fllen
         B_tx_puffer(b_tx_pos) = 2                          'Start of Text
         Incr B_tx_pos
         B_tx_puffer(b_tx_pos) = B_adress                   'Moduladresse
         Incr B_tx_pos
         B_tx_puffer(b_tx_pos) = 73                         'I
         Incr B_tx_pos
         B_tx_puffer(b_tx_pos) = I + 49                     'Tastennummer
         Incr B_tx_pos
         If B_taster(1).i = 0 Then                          'Fallende Flanke
            B_tx_puffer(b_tx_pos) = 48                      '0
         Else
            B_tx_puffer(b_tx_pos) = 49                      '1
         End If
         Incr B_tx_pos
         B_tx_puffer(b_tx_pos) = 3                          'End of Text
      End If
   Next I
Return


'Temperatur Mittelwert berechnen und senden
P_temp_senden:                                              'MCP9701 an ADC1
   I_temp = W_temperaturen(1) + W_temperaturen(2)
   I_temp = I_temp + W_temperaturen(3)
   I_temp = I_temp + W_temperaturen(4)
   W_temp = I_temp
   I_temp = I_temp * 25
   I_temp = I_temp - 16400
   W_temp = W_temp / 2
   I_temp = I_temp + W_temp
   W_temp = W_temp / 4
   I_temp = I_temp + W_temp
   I_temp = I_temp / 80
   S_temp = Str(i_temp)                                     'Temp in 1/10C
   'Kontrolle genug freier Puffer
   For B_tx_pos = 1 To Tx_max_length                        'ersten freien Platz im Array suchen
      If B_tx_puffer(b_tx_pos) = 0 Then Exit For
   Next B_tx_pos
   B_tx_pos = B_tx_pos + 8
   If B_tx_pos > Tx_max_length Then Return                  'Befehl verwerfen, wenn Sendepuffer voll
   B_tx_pos = B_tx_pos - 8
   'Sendepuffer fllen
   B_tx_puffer(b_tx_pos) = 2                                'Start of Text
   Incr B_tx_pos
   B_tx_puffer(b_tx_pos) = B_adress                         'Moduladresse
   Incr B_tx_pos
   B_tx_puffer(b_tx_pos) = 84                               'T
   For I = 1 To 10
      Incr B_tx_pos
      B_tx_puffer(b_tx_pos) = Bs_temp(i)
      If Bs_temp(i) = 0 Then Exit For                       'String Ende
   Next I
   B_tx_puffer(b_tx_pos) = 3                                'End of Text
Return

'Empfangene Telegramme auswerten
P_rx_auswertung:
   If B_rx_puffer(2) = B_adress Then                        'eigene Adresse
      'LED Ansteuern
      If B_rx_puffer(3) = 79 Then                           'O
         B_temp = B_rx_puffer(4) - 49                       'ASCII to Position
         If B_temp < 8 Then
            If B_rx_puffer(5) = 48 Then Reset B_led_puffer.b_temp       'LED ausschalten
            If B_rx_puffer(5) = 49 Then Set B_led_puffer.b_temp       'LED einschalten
            Gosub P_led_out
         End If

      'Taste Status abfragen
      Elseif B_rx_puffer(3) = 73 Then                       'I
         If B_rx_puffer(5) = 63 Then                        '?
            I = B_rx_puffer(4) - 49                         'ASCII to Position
            B_temp = 0
            If I < 8 Then Set B_temp.i
            Gosub P_taster_senden
         End If
      End If

      'Version abfragen
      If B_rx_puffer(4) = 87 Then                           'W
         If B_rx_puffer(5) = 63 Then                        '?
            'Kontrolle genug freier Puffer
            For B_tx_pos = 1 To Tx_max_length               'ersten freien Platz im Array suchen
               If B_tx_puffer(b_tx_pos) = 0 Then Exit For
            Next B_tx_pos
            B_tx_pos = B_tx_pos + 17
            If B_tx_pos > Tx_max_length Then B_rx_puffer(3) = 0       'Befehl verwerfen, wenn Sendepuffer voll
            B_tx_pos = B_tx_pos - 17
            'Hardwareversion
            If B_rx_puffer(3) = 72 Then                     'H
               'Sendepuffer fllen
               B_tx_puffer(b_tx_pos) = 2                    'Start of Text
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = B_adress             'Moduladresse
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 72                   'H
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 87                   'W
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 59                   ';
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = &H38                 '8 digitale Eingnge
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 59                   ';
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = &H38                 '8 digitale Ausgnge
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 59                   ';
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = &H31                 '1 Analoge Eingnge
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 59                   ';
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = &H30                 '0 Analoge Ausgnge
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 59                   ';
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = High(hw_vers)        'Hardwareversion
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = Low(hw_vers)         'Hardwareversion
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 3                    'End of Text
            End If
            'Firmwareversion
            If B_rx_puffer(3) = 70 Then                     'F
               'Sendepuffer fllen
               B_tx_puffer(b_tx_pos) = 2                    'Start of Text
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = B_adress             'Moduladresse
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 70                   'F
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 87                   'W
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = High(fw_vers)        'Firmwareversion
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = Low(fw_vers)         'Firmwareversion
               Incr B_tx_pos
               B_tx_puffer(b_tx_pos) = 3                    'End of Text
            End If
         End If
      End If
   End If

   'Bootloader aktivieren
   If B_rx_puffer(3) = 66 And B_rx_puffer(4) = 76 Then      'BL
      If B_rx_puffer(5) = 33 Then                           '!
         If B_rx_puffer(2) = B_adress Then                  'eigene Adresse -> aktiviere Bootloader
            Ucsrb.4 = 0                                     'Empfnger deaktivieren
            Printbin 2                                      'Besttigung senden
            Printbin B_adress
            Print "_Bootloader{003}";
            Stop Watchdog
            Stop Timer0
            B_led_puffer = &B10101010
            Gosub P_led_out
            Wait 10
            Goto &H1C00                                     'Starte Bootloader
         Else                                               'andere Adresse -> fr eine Minute nicht senden und empfangen
            Ucsrb.4 = 0
            Stop Timer0
            Stop Watchdog
            For I = 0 To 30
               B_temp = 255
               Spiout B_temp , 1
               Nop
               Set Ss_out
               Nop
               Reset Ss_out
               Wait 1
               B_temp = 0
               Spiout B_temp , 1
               Nop
               Set Ss_out
               Nop
               Reset Ss_out
               Wait 1
            Next I
            Reset Watchdog
            Start Watchdog
            Start Timer0
            Gosub P_led_out
            B_temp = Inkey()
            Ucsrb.4 = 1
         End If
      End If
   End If

   For I = 1 To Rx_max_length                               'Empfangspuffer lschen
      B_rx_puffer(i) = 0
   Next I
Return

'LED Ansteuerung
P_led_out:
   B_led_out.7 = B_led_puffer.3
   B_led_out.6 = B_led_puffer.2
   B_led_out.5 = B_led_puffer.1
   B_led_out.4 = B_led_puffer.0
   B_led_out.3 = B_led_puffer.7
   B_led_out.2 = B_led_puffer.6
   B_led_out.1 = B_led_puffer.5
   B_led_out.0 = B_led_puffer.4
   Spiout B_led_out , 1
   Nop                                                      'Waitms 1
   Set Ss_out
   Nop                                                      'Waitms 1
   Reset Ss_out
Return

'##############################################################################
'Interrupts
'##############################################################################
'500s.
Timer0_irq:
   If B_tx_off > 0 Then Decr B_tx_off                       'Sendesperre
   Incr B_zaehler_us
Return

'Speichert das Empfangene Zeichen in den B_RX_PUFFER
'Lscht den Puffer bei Empfang eines Start of Text
'Setzt den B_RX_LENGTH auf RX_MAX_LENGTH wenn End of Text empfangen wurde, Daten weiterverarbeitbar
Rx_irq:                                                     'Empfang an der Schnittstelle
   B_rx_puffer(rx_max_length) = Inkey()                     'Empfangenes Zeichen in letzten Puffer zwischenspeichern
   If B_rx_puffer(rx_max_length) = 2 Then                   'Start of Text, lsche gesamten Puffer
      For B_rx_length = 1 To Rx_max_length_m1
         B_rx_puffer(b_rx_length) = 0
      Next
      B_rx_length = 1
   End If
   If B_rx_puffer(rx_max_length) > 0 Then                   'Zeichen empfangen
      B_rx_puffer(b_rx_length) = B_rx_puffer(rx_max_length) 'Zeichen an aktuellen Platz kopieren
      B_rx_puffer(rx_max_length) = 0
      If B_rx_puffer(b_rx_length) = 3 Then B_rx_length = Rx_max_length       'End of Text
      If B_rx_length < Rx_max_length Then B_rx_length = B_rx_length + 1
      B_tx_off = B_adress + 5
   End If
Return